<template>
		<el-dialog v-model="state.dialogVisible" width="50%" draggable title="新增参数" destroy-on-close append-to-body @close="close">
			<el-form :model="state.ruleForm" label-width="90px" ref="ruleFormRef">
				<el-row :gutter="10">
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="参数名称" prop="settingName" :rules="[{ required: true, message: '请填写参数名称', trigger: 'blur' }]">
							<el-input v-model="state.ruleForm.settingName" placeholder="请填写参数名称" clearable></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="参数" prop="code" :rules="[{ required: true, message: '请填写参数', trigger: 'blur' }]">
							<el-input v-model.trim="state.ruleForm.code" placeholder="请填写参数" clearable></el-input>
						</el-form-item>
					</el-col>
					<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
						<el-form-item label="排序" prop="sort" :rules="[{ required: false, message: '请填写排序', trigger: 'blur' }]">
							<el-input-number v-model="state.ruleForm.sort" :min="1" :precision="0" class="w100"/>
						</el-form-item>
					</el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
            <el-form-item label="参数值" prop="settingValue" :rules="[{ required: false, message: '请填写参数值', trigger: 'blur' }]">
              <el-input
                type="textarea"
                v-model="state.ruleForm.settingValue"
                placeholder="有多个参数值,请以的|隔开,如1|2|3"
                clearable
              ></el-input>
            </el-form-item>
          </el-col>
					<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
						<el-form-item label="参数说明" prop="remark" :rules="[{ required: false, message: '请填写参数说明', trigger: 'blur' }]">
							<el-input
								type="textarea"
								:autosize="{ minRows: 6, maxRows: 10 }"
								v-model="state.ruleForm.remark"
								placeholder="请填写参数说明"
								clearable
							></el-input>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="closeDialog" class="default-button">取 消</el-button>
					<el-button type="primary" @click="onSubmit(ruleFormRef)" :loading="loading">确 定</el-button>
				</span>
			</template>
		</el-dialog>
</template>

<script setup lang="ts" name="parameterAdd">
import { reactive, ref } from 'vue';
import { ElMessage, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { SetingsAdd } from '@/api/system/parameter';
// 定义子组件向父组件传值/事件
const emit = defineEmits(['updateList']);

// 定义变量内容
const state = reactive<any>({
	dialogVisible: false,
	ruleForm: {
		settingName: '', // 参数名称
		code: '', // 参数
		settingValue: '', // 参数值
		sort: 1, // 排序
		remark: '', // 参数说明
	},
});
let loading = ref<boolean>(false);  // 加载状态
// 打开弹窗
const ruleFormRef = ref<RefType>();
const openDialog = async () => {
	ruleFormRef.value?.resetFields();
	try {
		state.dialogVisible = true;
	} catch (error) {
		console.log(error);
	}
};
// 关闭弹窗
const closeDialog = () => {
	state.dialogVisible = false;
};
const close = () => {
	ruleFormRef.value?.resetFields();
	ruleFormRef.value?.resetFields();
};
// 新增
const onSubmit = throttle(async (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	await formEl.validate((valid: boolean) => {
		if (!valid) return;
		loading.value = true;
		state.ruleForm.settingValue = state.ruleForm?.settingValue.split('|');
		SetingsAdd(state.ruleForm)
			.then(() => {
				ElMessage({
					message: '操作成功',
					type: 'success',
				});
				emit('updateList');
			})
			.catch(() => {
			})
			.finally(() => {
				loading.value = false;
				closeDialog();
			});
	});
}, 300);
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
